import {
  extent,
  scaleLinear,
  scaleTime,
  line,
} from 'd3';
import { axes } from './axes';

export const lineChart = (
  selection,
  {
    data,
    width,
    height,
    xValue,
    yValue,
    margin,
    xAxisLabel,
    yAxisLabel,
    circleRadius,
  }
) => {
 const xScale = scaleTime()
    .domain(extent(data, xValue))
    .range([margin.left, width - margin.right]);

  const yScale = scaleLinear()
    .domain(extent(data, yValue))
    .range([height - margin.bottom, margin.top]);

  selection.call(axes, {
    xScale,
    yScale,
    xAxisLabel,
    yAxisLabel,
  });

  // selection
  //   .selectAll('circle')
  //   .data(data)
  //   .join('circle')
  //   .attr('cx', (d) => xScale(xValue(d)))
  //   .attr('cy', (d) => yScale(yValue(d)))
  //   .attr('r', circleRadius);

  const lineGenerator = line()
    .x((d) => xScale(xValue(d)))
    .y((d) => yScale(yValue(d)));

  selection
    .selectAll('path.line')
    .data([null])
    .join('path')
    .attr('class', 'line')
    .attr('stroke', 'black')
    .attr('fill', 'none')
    .attr('d', lineGenerator(data));
};
